import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsLink, CmsLinkParam } from './model';


/**
 * 分页查询常用链接
 */
export async function pageCmsLink(params: CmsLinkParam) {
  const res = await request.get<ApiResult<PageResult<CmsLink>>>(
    '/cms/cms-link/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询常用链接列表
 */
export async function listCmsLink(params?: CmsLinkParam) {
  const res = await request.get<ApiResult<CmsLink[]>>(
    '/cms/cms-link',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加常用链接
 */
export async function addCmsLink(data: CmsLink) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-link',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改常用链接
 */
export async function updateCmsLink(data: CmsLink) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-link',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除常用链接
 */
export async function removeCmsLink(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-link/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除常用链接
 */
export async function removeBatchCmsLink(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-link/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询常用链接
 */
export async function getCmsLink(id: number) {
  const res = await request.get<ApiResult<CmsLink>>(
    '/cms/cms-link/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
